--
-- $Id$
--
-- Script containing customer specific sql statements for the Vesteda database

DEFINE thisfile = 'VEST.SQL'
DEFINE dbuser   = '^VEST'
DEFINE custid   = 'VEST'

SET ECHO ON
SET DEFINE ON
COLUMN fcltlogfile NEW_VALUE fcltlogfile NOPRINT;
WHENEVER SQLERROR EXIT;
SELECT adm.scriptspoolfile('&dbuser', '&thisfile') AS fcltlogfile FROM DUAL;
WHENEVER SQLERROR CONTINUE;
SPOOL &fcltlogfile
SET DEFINE OFF

------ payload begin ------

--
-- Personen import
--

CREATE OR REPLACE PROCEDURE vest_import_perslid (p_import_key IN NUMBER)
AS
   oracle_err_num            NUMBER;
   oracle_err_mes            VARCHAR2 (200);
   v_errormsg                VARCHAR2 (400);
   v_errorhint               VARCHAR2 (400);
   v_newline                 FAC_IMP_FILE.FAC_IMP_FILE_LINE%TYPE;
BEGIN

   BEGIN
      SELECT fac_imp_file_line
        INTO v_newline
        FROM fac_imp_file
       WHERE fac_import_key = p_import_key
         AND fac_imp_file_index = 1;

      IF v_newline LIKE
                  CHR (TO_NUMBER ('EF', 'xx'))
               || CHR (TO_NUMBER ('BB', 'xx'))
               || CHR (TO_NUMBER ('BF', 'xx'))
               || '%'
      THEN
         -- EF BB BF aangetroffen
         fac.imp_writelog (p_import_key,
                           'W',
                           'Byte Order Mark aangetroffen',
                           'Bestand heeft onbehandeld UTF-8 formaat.'
                          );
         v_newline := SUBSTR (v_newline, 4);
      END IF;

      -- Verwijder de dubbele quotes
      v_newline := REPLACE (v_newline, '"');

      UPDATE fac_imp_file
         SET fac_imp_file_line = v_newline
       WHERE fac_import_key = p_import_key
         AND fac_imp_file_index = 1;


   EXCEPTION WHEN OTHERS
   THEN
      fac.imp_writelog (p_import_key,
                        'E',
                        'Fout bij controle op Byte Order Mark',
                        ''
                       );
   END;


   v_errorhint := 'Generieke update';
   -- de sequence array staat beschreven in PRS_PAC.SRC bij de prs.import_perslid proc
   prs.import_perslid (p_import_key,
                       '13;14;15;16;0;0;6;1;3;2;' ||
                       '0;0;0;0;9;10;11;5;0;12;' ||
                       '7;4;0;8;0;0;0;0;0;0;'||
                       '0;0;0;0;0;0;0;0;0;0;'||
                       '0;0;0;0;0;0',
                       'Achternaam;Voornaam;Tussenvoegsel;SamAccountName;Email;Afdeling;Functie;Titel/Aanhef;Geslacht;Telefoonnummer;Mobiel nummer;Personeelsnummer;Locatie;Gebouw;Verdieping;Ruimte%'
                       );

UPDATE fac_imp_perslid
SET alg_locatie_code = (
SELECT a.alg_locatie_code
FROM alg_locatie a
WHERE fac_imp_perslid.alg_locatie_code = a.alg_locatie_omschrijving);

UPDATE fac_imp_perslid
SET alg_gebouw_code = '001'
WHERE fac_imp_perslid.alg_locatie_code LIKE '%AMS%';

UPDATE fac_imp_perslid
SET alg_verdieping_volgnr = '0'
WHERE fac_imp_perslid.alg_locatie_code LIKE '%AMS%';

UPDATE fac_imp_perslid
SET alg_ruimte_nr = '001'
WHERE fac_imp_perslid.alg_locatie_code LIKE '%AMS%';


UPDATE fac_imp_perslid
SET prs_afdeling_naam = 
(
  SELECT DISTINCT p.prs_afdeling_naam
  FROM prs_afdeling p
  WHERE fac_imp_perslid.prs_afdeling_naam = substr (p.prs_afdeling_omschrijving, 1, 15)
  AND p.prs_afdeling_verwijder IS NULL
)
WHERE fac_imp_perslid.prs_afdeling_naam NOT IN (SELECT p.prs_afdeling_naam FROM prs_afdeling p);

DELETE FROM fac_imp_perslid
WHERE alg_locatie_code NOT IN (SELECT alg_locatie_code FROM alg_locatie);

  COMMIT;
EXCEPTION
   WHEN OTHERS
   THEN
      oracle_err_num := SQLCODE;
      oracle_err_mes := SUBSTR (SQLERRM, 1, 100);
      v_errormsg := 'Error ' || oracle_err_num || '/' || oracle_err_mes;
      fac.imp_writelog (p_import_key, 'E', v_errormsg, v_errorhint);
END vest_import_perslid;
/

CREATE OR REPLACE PROCEDURE vest_update_perslid (
   p_import_key IN NUMBER
) IS
  -- Alle personen verwijderen die niet meer in import bestand voorkomen.
  CURSOR c_del
  IS
      SELECT p.prs_perslid_key, p.prs_perslid_oslogin, pf.prs_perslid_naam_full
        FROM fac_imp_perslid i, prs_perslid p, prs_v_perslid_fullnames_all pf
       WHERE UPPER (p.prs_perslid_oslogin) = UPPER (i.prs_perslid_oslogin(+))
         AND pf.prs_perslid_key = p.prs_perslid_key
         AND p.prs_perslid_oslogin IS NOT NULL
         AND i.prs_perslid_oslogin IS NULL
         AND p.prs_perslid_verwijder IS NULL
         AND substr(p.prs_perslid_oslogin, 1, 1) != '_'
    ORDER BY 2;

  v_count           NUMBER;

BEGIN
    -- generic update

    SELECT count(*)
      INTO v_count
      FROM fac_imp_perslid;

    IF v_count < 150
    THEN
      fac.imp_writelog (p_import_key,
                        'E',
                        'Het aantal te importeren personen is te klein ('
                        || TO_CHAR (v_count) || ')',
                        'Zie Specificatie'
      );
      RETURN;
    END IF;

  -- 'LOGIN' betekent dat op basis van oslogin wordt gematched.
  -- 'A' betekent altijd alle (andere/overige) werkplekken verwijderen
  prs.update_perslid (p_import_key, 'LOGIN', NULL);

  -- Verwijder personen die niet meer in de import voorkomen.
  FOR rec IN c_del
  LOOP
     BEGIN
       prs.delete_perslid (p_import_key, rec.prs_perslid_key);
     END;
  END LOOP;

END vest_update_perslid;
/

CREATE OR REPLACE VIEW VEST_V_RAP_CATERINGDAGLIJST
(
   RESKEY,
   FCLT_F_DATUM,
   RESNR,
   VAN,
   TOT,
   FCLT_F_RUIMTE,
   FCLT_F_CATALOGUS,
   LEVERING,
   VOORZIENING,
   AANTAL,
   OPMERKING,
   AANTAL_PERS,
   FCLT_F_GASTHEER_VROUW
)
AS
   SELECT rr.res_rsv_ruimte_key,
          rr.res_rsv_ruimte_van,
          rr.res_reservering_key || '/' || rr.res_rsv_ruimte_volgnr,
          TO_CHAR (rr.res_rsv_ruimte_van, 'hh24:mi'),
          TO_CHAR (rr.res_rsv_ruimte_tot, 'hh24:mi'),
          r.alg_ruimte_nr || ' ' || r.alg_ruimte_omschrijving,
          rd.ins_discipline_omschrijving,
          TO_CHAR (rra.res_rsv_artikel_levering, 'hh24:mi'),
          TRIM (ra.res_artikel_omschrijving),
          rra.res_rsv_artikel_aantal,
          rr.res_rsv_ruimte_opmerking,
          rr.res_rsv_ruimte_bezoekers,
          prs_perslid_naam_full
     FROM res_rsv_ruimte rr,
          alg_ruimte r,
          res_artikel ra,
          res_rsv_artikel rra,
          prs_v_perslid_fullnames ppf,
          res_reservering re,
          res_discipline rd
    WHERE     rr.alg_ruimte_key = r.alg_ruimte_key
          AND rra.res_rsv_ruimte_key = rr.res_rsv_ruimte_key
          AND rra.res_artikel_key = ra.res_artikel_key
          AND rr.res_rsv_ruimte_contact_key = ppf.prs_perslid_key
          AND rr.res_rsv_ruimte_host_key = ppf.prs_perslid_key
          AND ra.res_discipline_key = rd.ins_discipline_key
          AND re.res_reservering_key = rr.res_reservering_key
          AND re.res_reservering_verwijder IS NULL;
          
CREATE OR REPLACE VIEW vest_v_rap_mahler
(
   datum,
   stempelnummer,
   datum_uitgifte,
   inrijdtijd,
   uitrijdtijd,
   naam_bezoeker,
   bedrijf,
   maand
)
AS
   SELECT m.mld_melding_datum,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 1)
             stempelnummer,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 21)
             datum_uitgifte,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 24)
             inrijdtijd,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 25)
             uitrijdtijd,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 22)
             naam_bezoeker,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 23)
             bedrijf,
          TO_CHAR (m.mld_melding_datum, 'MM-YYYY') maand
     FROM mld_melding m
    WHERE m.mld_stdmelding_key = 81;
    
CREATE OR REPLACE VIEW vest_v_rap_kluistoegang
(
   datum,
   bevoegd_persoon_1,
   bevoegd_persoon_2,
   datum_toegang,
   reden_toegang,
   maand
)
AS
   SELECT m.mld_melding_datum,
          (SELECT pf.prs_perslid_naam_friendly
             FROM prs_v_perslid_fullnames pf
            WHERE pf.prs_perslid_key =
                     (SELECT mld_kenmerkmelding_waarde
                        FROM mld_kenmerkmelding km, mld_kenmerk k
                       WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                             AND km.mld_melding_key = m.mld_melding_key
                             AND k.mld_srtkenmerk_key = 41))
             bp1,
          (SELECT pf.prs_perslid_naam_friendly
             FROM prs_v_perslid_fullnames pf
            WHERE pf.prs_perslid_key =
                     (SELECT mld_kenmerkmelding_waarde
                        FROM mld_kenmerkmelding km, mld_kenmerk k
                       WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                             AND km.mld_melding_key = m.mld_melding_key
                             AND k.mld_srtkenmerk_key = 42))
             bp2,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 44)
             datum_toegang,
          (SELECT mld_kenmerkmelding_waarde
             FROM mld_kenmerkmelding km, mld_kenmerk k
            WHERE     km.mld_kenmerk_key = k.mld_kenmerk_key
                  AND km.mld_melding_key = m.mld_melding_key
                  AND k.mld_srtkenmerk_key = 43)
             reden_toegang,
          TO_CHAR (m.mld_melding_datum, 'MM-YYYY') maand
     FROM mld_melding m
    WHERE m.mld_stdmelding_key = 101;
          
------ payload end   ------

SET DEFINE OFF
BEGIN adm.systrackscriptId ('$Id$', 0); END;
/

COMMIT;
SET ECHO OFF
SPOOL OFF
SET DEFINE ON
PROMPT Logfile of this upgrade is: &fcltlogfile